# coding: utf-8

"""
    CloudEndure API documentation

    © 2017 CloudEndure All rights reserved  # General Request authentication in CloudEndure's API is done using session cookies. A session cookie is returned upon successful execution of the \"login\" method. This value must then be provided within the request headers of all subsequent API requests.  ## Errors Some errors are not specifically written in every method since they may always return. Those are: 1) 401 (Unauthorized) - for unauthenticated requests. 2) 405 (Method Not Allowed) - for using a method that is not supported (POST instead of GET). 3) 403 (Forbidden) - request is authenticated, but the user is not allowed to access. 4) 422 (Unprocessable Entity) - for invalid input.  ## Formats All strings with date-time format are according to RFC3339.  All strings with \"duration\" format are according to ISO8601. For example, a full day duration can be specified with \"PNNNND\".   # noqa: E501

    OpenAPI spec version: 5
    Contact: https://bit.ly/2T54hSc
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

from cloudendure.cloudendure_api.models.cloud_endure_find_files_result import (  # noqa: F401,E501
    CloudEndureFindFilesResult,
)


class CloudEndureFindFilesResults:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "count": "int",
        "query": "str",
        "items": "list[CloudEndureFindFilesResult]",
        "invalid_machine_i_ds": "list[str]",
    }

    attribute_map = {
        "count": "count",
        "query": "query",
        "items": "items",
        "invalid_machine_i_ds": "invalidMachineIDs",
    }

    def __init__(
        self, count=None, query=None, items=None, invalid_machine_i_ds=None
    ):  # noqa: E501
        """CloudEndureFindFilesResults - a model defined in Swagger"""  # noqa: E501
        self._count = None
        self._query = None
        self._items = None
        self._invalid_machine_i_ds = None
        self.discriminator = None
        self.count = count
        self.query = query
        if items is not None:
            self.items = items
        if invalid_machine_i_ds is not None:
            self.invalid_machine_i_ds = invalid_machine_i_ds

    @property
    def count(self):
        """Gets the count of this CloudEndureFindFilesResults.  # noqa: E501


        :return: The count of this CloudEndureFindFilesResults.  # noqa: E501
        :rtype: int
        """
        return self._count

    @count.setter
    def count(self, count):
        """Sets the count of this CloudEndureFindFilesResults.


        :param count: The count of this CloudEndureFindFilesResults.  # noqa: E501
        :type: int
        """
        if count is None:
            raise ValueError(
                "Invalid value for `count`, must not be `None`"
            )  # noqa: E501

        self._count = count

    @property
    def query(self):
        """Gets the query of this CloudEndureFindFilesResults.  # noqa: E501


        :return: The query of this CloudEndureFindFilesResults.  # noqa: E501
        :rtype: str
        """
        return self._query

    @query.setter
    def query(self, query):
        """Sets the query of this CloudEndureFindFilesResults.


        :param query: The query of this CloudEndureFindFilesResults.  # noqa: E501
        :type: str
        """
        if query is None:
            raise ValueError(
                "Invalid value for `query`, must not be `None`"
            )  # noqa: E501

        self._query = query

    @property
    def items(self):
        """Gets the items of this CloudEndureFindFilesResults.  # noqa: E501


        :return: The items of this CloudEndureFindFilesResults.  # noqa: E501
        :rtype: list[CloudEndureFindFilesResult]
        """
        return self._items

    @items.setter
    def items(self, items):
        """Sets the items of this CloudEndureFindFilesResults.


        :param items: The items of this CloudEndureFindFilesResults.  # noqa: E501
        :type: list[CloudEndureFindFilesResult]
        """

        self._items = items

    @property
    def invalid_machine_i_ds(self):
        """Gets the invalid_machine_i_ds of this CloudEndureFindFilesResults.  # noqa: E501


        :return: The invalid_machine_i_ds of this CloudEndureFindFilesResults.  # noqa: E501
        :rtype: list[str]
        """
        return self._invalid_machine_i_ds

    @invalid_machine_i_ds.setter
    def invalid_machine_i_ds(self, invalid_machine_i_ds):
        """Sets the invalid_machine_i_ds of this CloudEndureFindFilesResults.


        :param invalid_machine_i_ds: The invalid_machine_i_ds of this CloudEndureFindFilesResults.  # noqa: E501
        :type: list[str]
        """

        self._invalid_machine_i_ds = invalid_machine_i_ds

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(CloudEndureFindFilesResults, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CloudEndureFindFilesResults):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
