# coding: utf-8

"""
    CloudEndure API documentation

    © 2017 CloudEndure All rights reserved  # General Request authentication in CloudEndure's API is done using session cookies. A session cookie is returned upon successful execution of the \"login\" method. This value must then be provided within the request headers of all subsequent API requests.  ## Errors Some errors are not specifically written in every method since they may always return. Those are: 1) 401 (Unauthorized) - for unauthenticated requests. 2) 405 (Method Not Allowed) - for using a method that is not supported (POST instead of GET). 3) 403 (Forbidden) - request is authenticated, but the user is not allowed to access. 4) 422 (Unprocessable Entity) - for invalid input.  ## Formats All strings with date-time format are according to RFC3339.  All strings with \"duration\" format are according to ISO8601. For example, a full day duration can be specified with \"PNNNND\".   # noqa: E501

    OpenAPI spec version: 5
    Contact: https://bit.ly/2T54hSc
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class CloudEndureProjectStorage:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "project_id": "str",
        "points_in_time_total_bytes": "int",
        "running_machines_total_bytes": "int",
        "working_storage": "object",
        "calculation_date_time": "datetime",
    }

    attribute_map = {
        "project_id": "projectId",
        "points_in_time_total_bytes": "pointsInTimeTotalBytes",
        "running_machines_total_bytes": "runningMachinesTotalBytes",
        "working_storage": "workingStorage",
        "calculation_date_time": "calculationDateTime",
    }

    def __init__(
        self,
        project_id=None,
        points_in_time_total_bytes=None,
        running_machines_total_bytes=None,
        working_storage=None,
        calculation_date_time=None,
    ):  # noqa: E501
        """CloudEndureProjectStorage - a model defined in Swagger"""  # noqa: E501
        self._project_id = None
        self._points_in_time_total_bytes = None
        self._running_machines_total_bytes = None
        self._working_storage = None
        self._calculation_date_time = None
        self.discriminator = None
        if project_id is not None:
            self.project_id = project_id
        if points_in_time_total_bytes is not None:
            self.points_in_time_total_bytes = points_in_time_total_bytes
        if running_machines_total_bytes is not None:
            self.running_machines_total_bytes = running_machines_total_bytes
        if working_storage is not None:
            self.working_storage = working_storage
        if calculation_date_time is not None:
            self.calculation_date_time = calculation_date_time

    @property
    def project_id(self):
        """Gets the project_id of this CloudEndureProjectStorage.  # noqa: E501


        :return: The project_id of this CloudEndureProjectStorage.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this CloudEndureProjectStorage.


        :param project_id: The project_id of this CloudEndureProjectStorage.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def points_in_time_total_bytes(self):
        """Gets the points_in_time_total_bytes of this CloudEndureProjectStorage.  # noqa: E501


        :return: The points_in_time_total_bytes of this CloudEndureProjectStorage.  # noqa: E501
        :rtype: int
        """
        return self._points_in_time_total_bytes

    @points_in_time_total_bytes.setter
    def points_in_time_total_bytes(self, points_in_time_total_bytes):
        """Sets the points_in_time_total_bytes of this CloudEndureProjectStorage.


        :param points_in_time_total_bytes: The points_in_time_total_bytes of this CloudEndureProjectStorage.  # noqa: E501
        :type: int
        """

        self._points_in_time_total_bytes = points_in_time_total_bytes

    @property
    def running_machines_total_bytes(self):
        """Gets the running_machines_total_bytes of this CloudEndureProjectStorage.  # noqa: E501


        :return: The running_machines_total_bytes of this CloudEndureProjectStorage.  # noqa: E501
        :rtype: int
        """
        return self._running_machines_total_bytes

    @running_machines_total_bytes.setter
    def running_machines_total_bytes(self, running_machines_total_bytes):
        """Sets the running_machines_total_bytes of this CloudEndureProjectStorage.


        :param running_machines_total_bytes: The running_machines_total_bytes of this CloudEndureProjectStorage.  # noqa: E501
        :type: int
        """

        self._running_machines_total_bytes = running_machines_total_bytes

    @property
    def working_storage(self):
        """Gets the working_storage of this CloudEndureProjectStorage.  # noqa: E501


        :return: The working_storage of this CloudEndureProjectStorage.  # noqa: E501
        :rtype: object
        """
        return self._working_storage

    @working_storage.setter
    def working_storage(self, working_storage):
        """Sets the working_storage of this CloudEndureProjectStorage.


        :param working_storage: The working_storage of this CloudEndureProjectStorage.  # noqa: E501
        :type: object
        """

        self._working_storage = working_storage

    @property
    def calculation_date_time(self):
        """Gets the calculation_date_time of this CloudEndureProjectStorage.  # noqa: E501


        :return: The calculation_date_time of this CloudEndureProjectStorage.  # noqa: E501
        :rtype: datetime
        """
        return self._calculation_date_time

    @calculation_date_time.setter
    def calculation_date_time(self, calculation_date_time):
        """Sets the calculation_date_time of this CloudEndureProjectStorage.


        :param calculation_date_time: The calculation_date_time of this CloudEndureProjectStorage.  # noqa: E501
        :type: datetime
        """

        self._calculation_date_time = calculation_date_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(CloudEndureProjectStorage, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CloudEndureProjectStorage):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
